using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using Microsoft.Win32; // for registery classes


namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		bool isDirty;
		string currentFilename ;
		Finder finder;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.ColorDialog colorDialog1;
		private System.Windows.Forms.MenuItem File;
		private System.Windows.Forms.MenuItem New;
		private System.Windows.Forms.MenuItem Open;
		private System.Windows.Forms.MenuItem Save;
		private System.Windows.Forms.MenuItem SaveAs;
		private System.Windows.Forms.MenuItem Exit;
		private System.Windows.Forms.MenuItem Edit;
		private System.Windows.Forms.MenuItem Copy;
		private System.Windows.Forms.MenuItem Cut;
		private System.Windows.Forms.MenuItem Paste;
		private System.Windows.Forms.MenuItem mnuColorBack;
		private System.Windows.Forms.MenuItem mnuColorText;
		private System.Windows.Forms.ErrorProvider errorProvider1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem Find;
		private System.Windows.Forms.RichTextBox txtNotePad;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			if (GetSetting() == false)
				MessageBox.Show("No info in Registery");
			else
				this.StartPosition = FormStartPosition.Manual; 

			currentFilename = "";
			isDirty = false;
			finder = new Finder(this);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			SaveSetting();
			base.Dispose( disposing );
		}

	
 



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtNotePad = new System.Windows.Forms.RichTextBox();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.File = new System.Windows.Forms.MenuItem();
			this.New = new System.Windows.Forms.MenuItem();
			this.Open = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.Save = new System.Windows.Forms.MenuItem();
			this.SaveAs = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.Exit = new System.Windows.Forms.MenuItem();
			this.Edit = new System.Windows.Forms.MenuItem();
			this.Copy = new System.Windows.Forms.MenuItem();
			this.Cut = new System.Windows.Forms.MenuItem();
			this.Paste = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.Find = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.mnuColorBack = new System.Windows.Forms.MenuItem();
			this.mnuColorText = new System.Windows.Forms.MenuItem();
			this.colorDialog1 = new System.Windows.Forms.ColorDialog();
			this.errorProvider1 = new System.Windows.Forms.ErrorProvider();
			this.SuspendLayout();
			// 
			// txtNotePad
			// 
			this.txtNotePad.Location = new System.Drawing.Point(0, 0);
			this.txtNotePad.Name = "txtNotePad";
			this.txtNotePad.Size = new System.Drawing.Size(488, 344);
			this.txtNotePad.TabIndex = 0;
			this.txtNotePad.Text = "";
			this.txtNotePad.TextChanged += new System.EventHandler(this.txtNotePad_TextChanged);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 352);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(488, 22);
			this.statusBar1.TabIndex = 1;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.File,
																					  this.Edit,
																					  this.menuItem13});
			// 
			// File
			// 
			this.File.Index = 0;
			this.File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				 this.New,
																				 this.Open,
																				 this.menuItem4,
																				 this.Save,
																				 this.SaveAs,
																				 this.menuItem7,
																				 this.Exit});
			this.File.Text = "File";
			// 
			// New
			// 
			this.New.Index = 0;
			this.New.Text = "New";
			this.New.Click += new System.EventHandler(this.New_Click);
			// 
			// Open
			// 
			this.Open.Index = 1;
			this.Open.Text = "Open";
			this.Open.Click += new System.EventHandler(this.Open_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			// 
			// Save
			// 
			this.Save.Index = 3;
			this.Save.Text = "Save";
			this.Save.Click += new System.EventHandler(this.Save_Click);
			// 
			// SaveAs
			// 
			this.SaveAs.Index = 4;
			this.SaveAs.Text = "Save As";
			this.SaveAs.Click += new System.EventHandler(this.SaveAs_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 5;
			this.menuItem7.Text = "-";
			// 
			// Exit
			// 
			this.Exit.Index = 6;
			this.Exit.Text = "Exit";
			this.Exit.Click += new System.EventHandler(this.Exit_Click);
			// 
			// Edit
			// 
			this.Edit.Index = 1;
			this.Edit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																				 this.Copy,
																				 this.Cut,
																				 this.Paste,
																				 this.menuItem1,
																				 this.Find});
			this.Edit.Text = "Edit";
			// 
			// Copy
			// 
			this.Copy.Index = 0;
			this.Copy.Text = "Copy";
			this.Copy.Click += new System.EventHandler(this.Copy_Click);
			// 
			// Cut
			// 
			this.Cut.Index = 1;
			this.Cut.Text = "Cut";
			this.Cut.Click += new System.EventHandler(this.Cut_Click);
			// 
			// Paste
			// 
			this.Paste.Index = 2;
			this.Paste.Text = "Paste";
			this.Paste.Click += new System.EventHandler(this.Paste_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// Find
			// 
			this.Find.Index = 4;
			this.Find.Text = "Find";
			this.Find.Click += new System.EventHandler(this.Find_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuColorBack,
																					   this.mnuColorText});
			this.menuItem13.Text = "Color";
			// 
			// mnuColorBack
			// 
			this.mnuColorBack.Index = 0;
			this.mnuColorBack.Text = "Back Color";
			this.mnuColorBack.Click += new System.EventHandler(this.BackColor_Click);
			// 
			// mnuColorText
			// 
			this.mnuColorText.Index = 1;
			this.mnuColorText.Text = "Text Color";
			this.mnuColorText.Click += new System.EventHandler(this.TextColor_Click);
			// 
			// errorProvider1
			// 
			this.errorProvider1.ContainerControl = this;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 374);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.txtNotePad);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Resize(object sender, System.EventArgs e)

		{

			txtNotePad.Left = 0;

			txtNotePad.Top = 0;

			txtNotePad.Width = ClientRectangle.Width;

			txtNotePad.Height = ClientRectangle.Height;

		}



		private void Form1_Load(object sender, System.EventArgs e)
		{
			Form1_Resize(sender,e);
		}

	    private void Copy_Click(object sender, System.EventArgs e)
        {
			txtNotePad.Copy();
        }

 

      private void Cut_Click(object sender, System.EventArgs e)
      {
         txtNotePad.Cut();
      }

 

      private void Paste_Click(object sender, System.EventArgs e)
      {
         txtNotePad.Paste();
      }

 

      private void Open_Click(object sender, System.EventArgs e)
      {
		  if (isDirty)
			  PromptSave();



         txtNotePad.Text = "";

         currentFilename="";

         OpenFileDialog openfDlg = new OpenFileDialog();

         openfDlg.Filter = "Text Files | *.txt";

         string filename;

         if (openfDlg.ShowDialog() == DialogResult.OK)
         {
            filename = openfDlg.FileName;
            currentFilename = filename;
            FileInfo fi = new FileInfo(filename);
            StreamReader rstr = fi.OpenText();
            string []sline = new string[65535];
               // max lines a text box can hold

            int count = 0;
            if (rstr != null)
            {
               count = 0;
               sline[count++] = rstr.ReadLine();

               while (sline[count-1] != null)
               {                              
                  sline[count++] = rstr.ReadLine();
                  if (count >= 65536) break;
               }

               
               rstr.Close();
               string []finalSize = new String[count];
               // find exact size of line array otherwise blank
               // blank lines will show up in editor
               for (int i = 0; i < count; i++)
                  finalSize[i]=sline[i];

               txtNotePad.Lines = finalSize;
            }

         }

      }

 

      private void SaveAs_Click(object sender, System.EventArgs e)
      {
         string filename="";
         SaveFileDialog savefDlg = new SaveFileDialog();
         if (savefDlg.ShowDialog() == DialogResult.OK)
         {
            filename = savefDlg.FileName;
            SaveData(filename);
			currentFilename = filename; 
         }

      }

 

	  private void Save_Click(object sender, System.EventArgs e)
	  {
		  if(currentFilename == "")
		  {
				SaveAs_Click(sender, e);
			  //saver = new SaveFileDialog();
			  //saver.ShowDialog();
			  //if ( saver.ShowDialog() == DialogResult.OK )
			  //  SaveData(saver.FileName);
		  }
		  else
		  {
			  SaveData(currentFilename);
		  }
	
      }

 

      private void SaveData(string filename)
      {
         
         StreamWriter wstr = new StreamWriter(filename,false,System.Text.Encoding.Unicode);
         foreach(string sline in txtNotePad.Lines)
            wstr.WriteLine(sline);

         wstr.Close();
         txtNotePad.SelectionLength=0;
		 isDirty = false;
      }

 

      private void New_Click(object sender, System.EventArgs e)
      {
		  if (isDirty)
			  PromptSave();


         txtNotePad.Text = "";
         currentFilename="";

      }

 

      private void Exit_Click(object sender, System.EventArgs e)
      {
		 if (isDirty)
			  PromptSave();
		 SaveSetting(); 
         Application.Exit();

      }

 

      private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
      {
		  if (isDirty)
			  PromptSave();
		  SaveSetting(); 

         Exit_Click(sender,e);
      }

 

      private void BackColor_Click(object sender, System.EventArgs e)
      {

         ColorDialog cd = new ColorDialog();

         if (cd.ShowDialog() == DialogResult.OK)
            txtNotePad.BackColor = cd.Color; 

      }

 

      private void TextColor_Click(object sender, System.EventArgs e)
      {

         ColorDialog cd = new ColorDialog();

         if (cd.ShowDialog() == DialogResult.OK)
            txtNotePad.ForeColor = cd.Color;

      }



		public bool FindMyText(string text)
		{
			// Initialize the return value to false by default.
			bool returnValue = false;

			// Ensure a search string has been specified.
			if (text.Length > 0) 
			{
				// Obtain the location of the search string in richTextBox1.
				int indexToText = txtNotePad.Find(text);

				// Determine whether the text was found in richTextBox1.
				if(indexToText >= 0)
				{
					txtNotePad.Select(indexToText, text.Length);
					returnValue = true;
				}
			}

			return returnValue;
		}

	
	
		private void Find_Click( object sender, System.EventArgs e)
		{
			// FindMyText("blah");

			this.finder.Show();
		}
	
		private void txtNotePad_TextChanged(object sender, System.EventArgs e)
		{
			isDirty = true;
		}

		private void PromptSave()
		{
			string question;

			if (currentFilename == "")
				question = "Save Changes to a File?";
			else
				question = "Save Changes Made in "+ currentFilename;

        

			if (MessageBox.Show(question,"Save File?",MessageBoxButtons.YesNo) == DialogResult.Yes)
			{
				if (currentFilename == "")
					SaveAs_Click(null,null);
				else
					Save_Click(null,null);

			}

		}

		void SaveSetting()  // saves info in registry
		{
			RegistryKey rk = Registry.LocalMachine;
			RegistryKey rkSw = rk.OpenSubKey("Software",true);
			RegistryKey rkAm = rkSw.CreateSubKey("AusifM Software");
			RegistryKey rkFr = rkAm.CreateSubKey("NotePadFrame");
			rkFr.SetValue("BackColor",(object)this.txtNotePad.BackColor.ToKnownColor());  
			rkFr.SetValue("Red",(object)(int)this.txtNotePad.BackColor.R);
			rkFr.SetValue("Green",(object)(int)this.txtNotePad.BackColor.G);
			rkFr.SetValue("Blue",(object)(int)this.txtNotePad.BackColor.B);

			rkFr.SetValue("ForeColor",(object)this.txtNotePad.ForeColor.ToKnownColor());  
			rkFr.SetValue("FRed",(object)(int)this.txtNotePad.ForeColor.R);
			rkFr.SetValue("FGreen",(object)(int)this.txtNotePad.ForeColor.G);
			rkFr.SetValue("FBlue",(object)(int)this.txtNotePad.ForeColor.B);

			rkFr.SetValue("Width",(object)this.Width);
			rkFr.SetValue("Height",(object)this.Height);
			rkFr.SetValue("X",(object)this.DesktopLocation.X);
			rkFr.SetValue("Y",(object)this.DesktopLocation.Y);
			rkFr.SetValue("WindowState",(object)this.WindowState.ToString());
			rkFr.Close();

		}

    

		bool GetSetting()  // Retrieves info in registry
		{
			RegistryKey rk = Registry.LocalMachine;
			RegistryKey rkSw = rk.OpenSubKey("Software");
			RegistryKey rkAm = rkSw.OpenSubKey("AusifM Software");
			
			if (rkAm == null)
				return false;

			RegistryKey rkFr = rkAm.OpenSubKey("NotePadFrame");
			
			if (rkFr == null)
				return false;

			int red = (int)rkFr.GetValue("Red");
			int green = (int)rkFr.GetValue("Green");
			int blue = (int)rkFr.GetValue("Blue");
			txtNotePad.BackColor = Color.FromArgb(red,green,blue);

			int fred = (int)rkFr.GetValue("FRed");
			int fgreen = (int)rkFr.GetValue("FGreen");
			int fblue = (int)rkFr.GetValue("FBlue");
			txtNotePad.ForeColor = Color.FromArgb(fred,fgreen,fblue);

			int x = (int)rkFr.GetValue("X");
			int y = (int)rkFr.GetValue("Y");
			this.DesktopLocation = new Point(x,y);
			this.Width = (int)rkFr.GetValue("Width");
			this.Height = (int)rkFr.GetValue("Height");

			string wndState = (string)rkFr.GetValue("WindowState");
			this.WindowState = (FormWindowState) 
			FormWindowState.Parse(WindowState.GetType(),wndState);

			rkFr.Close();
			return true;
		}


	}
}
